# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from antimatter_api.models.available_delegated_root_encryption_key_provider import AvailableDelegatedRootEncryptionKeyProvider
from antimatter_api.models.available_service_account_root_encryption_key_provider import AvailableServiceAccountRootEncryptionKeyProvider
from pydantic import StrictStr, Field
from typing import Union, List, Optional, Dict
from typing_extensions import Literal, Self

AVAILABLEROOTENCRYPTIONKEYPROVIDERSPROVIDERSINNER_ONE_OF_SCHEMAS = ["AvailableDelegatedRootEncryptionKeyProvider", "AvailableServiceAccountRootEncryptionKeyProvider"]

class AvailableRootEncryptionKeyProvidersProvidersInner(BaseModel):
    """
    AvailableRootEncryptionKeyProvidersProvidersInner
    """
    # data type: AvailableDelegatedRootEncryptionKeyProvider
    oneof_schema_1_validator: Optional[AvailableDelegatedRootEncryptionKeyProvider] = None
    # data type: AvailableServiceAccountRootEncryptionKeyProvider
    oneof_schema_2_validator: Optional[AvailableServiceAccountRootEncryptionKeyProvider] = None
    actual_instance: Optional[Union[AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider]] = None
    one_of_schemas: List[str] = Field(default=Literal["AvailableDelegatedRootEncryptionKeyProvider", "AvailableServiceAccountRootEncryptionKeyProvider"])

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = AvailableRootEncryptionKeyProvidersProvidersInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: AvailableDelegatedRootEncryptionKeyProvider
        if not isinstance(v, AvailableDelegatedRootEncryptionKeyProvider):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AvailableDelegatedRootEncryptionKeyProvider`")
        else:
            match += 1
        # validate data type: AvailableServiceAccountRootEncryptionKeyProvider
        if not isinstance(v, AvailableServiceAccountRootEncryptionKeyProvider):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AvailableServiceAccountRootEncryptionKeyProvider`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in AvailableRootEncryptionKeyProvidersProvidersInner with oneOf schemas: AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in AvailableRootEncryptionKeyProvidersProvidersInner with oneOf schemas: AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AvailableDelegatedRootEncryptionKeyProvider
        try:
            instance.actual_instance = AvailableDelegatedRootEncryptionKeyProvider.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AvailableServiceAccountRootEncryptionKeyProvider
        try:
            instance.actual_instance = AvailableServiceAccountRootEncryptionKeyProvider.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into AvailableRootEncryptionKeyProvidersProvidersInner with oneOf schemas: AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AvailableRootEncryptionKeyProvidersProvidersInner with oneOf schemas: AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AvailableDelegatedRootEncryptionKeyProvider, AvailableServiceAccountRootEncryptionKeyProvider]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


