# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AzureServiceAccountKeyInfo(BaseModel):
    """
    The Azure service account information and details required to access the Azure HSM for cryptographic operations. 
    """ # noqa: E501
    tenant_id: StrictStr = Field(description="The Azure service account directory ID.", alias="tenantID")
    key_url: StrictStr = Field(description="The name of the key in Azure Key Vault.", alias="keyURL")
    client_id: StrictStr = Field(description="The access key ID's secret access key.", alias="clientID")
    client_secret: StrictStr = Field(description="The access key ID's secret access key.", alias="clientSecret")
    provider_name: Optional[StrictStr] = Field(default=None, alias="providerName")
    __properties: ClassVar[List[str]] = ["tenantID", "keyURL", "clientID", "clientSecret", "providerName"]

    @field_validator('provider_name')
    def provider_name_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['azure_sa']):
            raise ValueError("must be one of enum values ('azure_sa')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AzureServiceAccountKeyInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AzureServiceAccountKeyInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenantID": obj.get("tenantID"),
            "keyURL": obj.get("keyURL"),
            "clientID": obj.get("clientID"),
            "clientSecret": obj.get("clientSecret"),
            "providerName": obj.get("providerName")
        })
        return _obj


