# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictBytes, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CapsuleOpenResponseReadContextConfiguration(BaseModel):
    """
    the material required for enacting read context configuration (e.g. wasm stuff)
    """ # noqa: E501
    disable_read_logging: StrictBool = Field(description="If true, skip creation of audit log events on read", alias="disableReadLogging")
    key_cache_ttl: Annotated[int, Field(strict=True, ge=0)] = Field(description="Number of seconds for which cached encryption keys will be considered valid by the client ", alias="keyCacheTTL")
    policy_assembly: Union[StrictBytes, StrictStr] = Field(description="a bundled version of the Rego policy associated with this open event.", alias="policyAssembly")
    __properties: ClassVar[List[str]] = ["disableReadLogging", "keyCacheTTL", "policyAssembly"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CapsuleOpenResponseReadContextConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CapsuleOpenResponseReadContextConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "disableReadLogging": obj.get("disableReadLogging") if obj.get("disableReadLogging") is not None else False,
            "keyCacheTTL": obj.get("keyCacheTTL") if obj.get("keyCacheTTL") is not None else 0,
            "policyAssembly": obj.get("policyAssembly")
        })
        return _obj


