# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from antimatter_api.models.llm_classifier_config import LLMClassifierConfig
from antimatter_api.models.regex_classifier_config import RegexClassifierConfig
from antimatter_api.models.write_context_classifier_tag import WriteContextClassifierTag
from typing import Optional, Set
from typing_extensions import Self

class ClassifierRule(BaseModel):
    """
    Configuration for a classification hook.
    """ # noqa: E501
    id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="An identifier for a rule")
    comment: Optional[StrictStr] = None
    span_tags: List[WriteContextClassifierTag] = Field(alias="spanTags")
    capsule_tags: List[WriteContextClassifierTag] = Field(alias="capsuleTags")
    llm_config: Optional[LLMClassifierConfig] = Field(default=None, alias="llmConfig")
    regex_config: Optional[RegexClassifierConfig] = Field(default=None, alias="regexConfig")
    __properties: ClassVar[List[str]] = ["id", "comment", "spanTags", "capsuleTags", "llmConfig", "regexConfig"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^rl-[a-z0-9]{16}$", value):
            raise ValueError(r"must validate the regular expression /^rl-[a-z0-9]{16}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ClassifierRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in span_tags (list)
        _items = []
        if self.span_tags:
            for _item in self.span_tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['spanTags'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in capsule_tags (list)
        _items = []
        if self.capsule_tags:
            for _item in self.capsule_tags:
                if _item:
                    _items.append(_item.to_dict())
            _dict['capsuleTags'] = _items
        # override the default output from pydantic by calling `to_dict()` of llm_config
        if self.llm_config:
            _dict['llmConfig'] = self.llm_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of regex_config
        if self.regex_config:
            _dict['regexConfig'] = self.regex_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ClassifierRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "comment": obj.get("comment"),
            "spanTags": [WriteContextClassifierTag.from_dict(_item) for _item in obj["spanTags"]] if obj.get("spanTags") is not None else None,
            "capsuleTags": [WriteContextClassifierTag.from_dict(_item) for _item in obj["capsuleTags"]] if obj.get("capsuleTags") is not None else None,
            "llmConfig": LLMClassifierConfig.from_dict(obj["llmConfig"]) if obj.get("llmConfig") is not None else None,
            "regexConfig": RegexClassifierConfig.from_dict(obj["regexConfig"]) if obj.get("regexConfig") is not None else None
        })
        return _obj


