# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from antimatter_api.models.antimatter_delegated_aws_key_info import AntimatterDelegatedAWSKeyInfo
from antimatter_api.models.antimatter_delegated_azure_key_info import AntimatterDelegatedAzureKeyInfo
from antimatter_api.models.antimatter_delegated_gcp_key_info import AntimatterDelegatedGCPKeyInfo
from antimatter_api.models.aws_service_account_key_info import AWSServiceAccountKeyInfo
from antimatter_api.models.azure_service_account_key_info import AzureServiceAccountKeyInfo
from antimatter_api.models.byok_key_info import BYOKKeyInfo
from antimatter_api.models.gcp_service_account_key_info import GCPServiceAccountKeyInfo
from pydantic import StrictStr, Field
from typing import Union, List, Optional, Dict
from typing_extensions import Literal, Self

KEYINFOSKEYINFORMATION_ONE_OF_SCHEMAS = ["AWSServiceAccountKeyInfo", "AntimatterDelegatedAWSKeyInfo", "AntimatterDelegatedAzureKeyInfo", "AntimatterDelegatedGCPKeyInfo", "AzureServiceAccountKeyInfo", "BYOKKeyInfo", "GCPServiceAccountKeyInfo"]

class KeyInfosKeyInformation(BaseModel):
    """
    KeyInfosKeyInformation
    """
    # data type: GCPServiceAccountKeyInfo
    oneof_schema_1_validator: Optional[GCPServiceAccountKeyInfo] = None
    # data type: AntimatterDelegatedGCPKeyInfo
    oneof_schema_2_validator: Optional[AntimatterDelegatedGCPKeyInfo] = None
    # data type: AWSServiceAccountKeyInfo
    oneof_schema_3_validator: Optional[AWSServiceAccountKeyInfo] = None
    # data type: AntimatterDelegatedAWSKeyInfo
    oneof_schema_4_validator: Optional[AntimatterDelegatedAWSKeyInfo] = None
    # data type: AzureServiceAccountKeyInfo
    oneof_schema_5_validator: Optional[AzureServiceAccountKeyInfo] = None
    # data type: AntimatterDelegatedAzureKeyInfo
    oneof_schema_6_validator: Optional[AntimatterDelegatedAzureKeyInfo] = None
    # data type: BYOKKeyInfo
    oneof_schema_7_validator: Optional[BYOKKeyInfo] = None
    actual_instance: Optional[Union[AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo]] = None
    one_of_schemas: List[str] = Field(default=Literal["AWSServiceAccountKeyInfo", "AntimatterDelegatedAWSKeyInfo", "AntimatterDelegatedAzureKeyInfo", "AntimatterDelegatedGCPKeyInfo", "AzureServiceAccountKeyInfo", "BYOKKeyInfo", "GCPServiceAccountKeyInfo"])

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = KeyInfosKeyInformation.model_construct()
        error_messages = []
        match = 0
        # validate data type: GCPServiceAccountKeyInfo
        if not isinstance(v, GCPServiceAccountKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GCPServiceAccountKeyInfo`")
        else:
            match += 1
        # validate data type: AntimatterDelegatedGCPKeyInfo
        if not isinstance(v, AntimatterDelegatedGCPKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AntimatterDelegatedGCPKeyInfo`")
        else:
            match += 1
        # validate data type: AWSServiceAccountKeyInfo
        if not isinstance(v, AWSServiceAccountKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AWSServiceAccountKeyInfo`")
        else:
            match += 1
        # validate data type: AntimatterDelegatedAWSKeyInfo
        if not isinstance(v, AntimatterDelegatedAWSKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AntimatterDelegatedAWSKeyInfo`")
        else:
            match += 1
        # validate data type: AzureServiceAccountKeyInfo
        if not isinstance(v, AzureServiceAccountKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AzureServiceAccountKeyInfo`")
        else:
            match += 1
        # validate data type: AntimatterDelegatedAzureKeyInfo
        if not isinstance(v, AntimatterDelegatedAzureKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AntimatterDelegatedAzureKeyInfo`")
        else:
            match += 1
        # validate data type: BYOKKeyInfo
        if not isinstance(v, BYOKKeyInfo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BYOKKeyInfo`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in KeyInfosKeyInformation with oneOf schemas: AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in KeyInfosKeyInformation with oneOf schemas: AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into GCPServiceAccountKeyInfo
        try:
            instance.actual_instance = GCPServiceAccountKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AntimatterDelegatedGCPKeyInfo
        try:
            instance.actual_instance = AntimatterDelegatedGCPKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AWSServiceAccountKeyInfo
        try:
            instance.actual_instance = AWSServiceAccountKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AntimatterDelegatedAWSKeyInfo
        try:
            instance.actual_instance = AntimatterDelegatedAWSKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AzureServiceAccountKeyInfo
        try:
            instance.actual_instance = AzureServiceAccountKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AntimatterDelegatedAzureKeyInfo
        try:
            instance.actual_instance = AntimatterDelegatedAzureKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BYOKKeyInfo
        try:
            instance.actual_instance = BYOKKeyInfo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into KeyInfosKeyInformation with oneOf schemas: AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into KeyInfosKeyInformation with oneOf schemas: AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AWSServiceAccountKeyInfo, AntimatterDelegatedAWSKeyInfo, AntimatterDelegatedAzureKeyInfo, AntimatterDelegatedGCPKeyInfo, AzureServiceAccountKeyInfo, BYOKKeyInfo, GCPServiceAccountKeyInfo]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


