# coding: utf-8

"""
    Antimatter Public API

    Interact with the Antimatter Cloud API

    The version of the OpenAPI document: 2.0.1
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class NewDomainSettings(BaseModel):
    """
    Fields associated with a domain that are to be updated
    """ # noqa: E501
    active_admin_contacts: Optional[List[StrictStr]] = Field(default=None, description="A list of admin contact details that have been validated.", alias="activeAdminContacts")
    pending_admin_contacts: Optional[List[StrictStr]] = Field(default=None, description="A list of admin contact details that are pending validation.", alias="pendingAdminContacts")
    default_display_name: Optional[Annotated[str, Field(strict=True, max_length=40)]] = Field(default=None, description="User friendly custom display name.", alias="defaultDisplayName")
    default_token_lifetime: Optional[StrictInt] = Field(default=None, description="The default lifetime in seconds of a domain authentication token generated for this domain.", alias="defaultTokenLifetime")
    maximum_token_lifetime: Optional[StrictInt] = Field(default=None, description="The maximum lifetime in seconds that a domain authentication token can be generated for.", alias="maximumTokenLifetime")
    __properties: ClassVar[List[str]] = ["activeAdminContacts", "pendingAdminContacts", "defaultDisplayName", "defaultTokenLifetime", "maximumTokenLifetime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NewDomainSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NewDomainSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activeAdminContacts": obj.get("activeAdminContacts"),
            "pendingAdminContacts": obj.get("pendingAdminContacts"),
            "defaultDisplayName": obj.get("defaultDisplayName"),
            "defaultTokenLifetime": obj.get("defaultTokenLifetime"),
            "maximumTokenLifetime": obj.get("maximumTokenLifetime")
        })
        return _obj


